#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "myfunc.h"

void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_filechooserdialog1_ok_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget *fs;
 GtkWidget *parentWindow;
 GtkImage *image1;
 gint image1_w,image1_h;
 gchar *fn;
 GdkPixbuf *pixbuf1;
 GdkPixmap *pixmap1;
 extern GtkWidget *global_mainwindow;
 
 fs = GTK_WIDGET(button);
 fn = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (fs));
 g_print ("Open: %s\n", fn);
 gtk_widget_hide(fs);
 parentWindow = global_mainwindow;
 image1 = GTK_IMAGE(lookup_widget(parentWindow,"image1"));
 /* get image info */
 gdk_pixbuf_get_file_info(fn,&image1_w,&image1_h);
 /* new pixbuf */
 pixbuf1 = gdk_pixbuf_new_from_file(fn,NULL);
 setmypixbuf(pixbuf1);
 /* new pixmap */
 pixmap1 = gdk_pixmap_new(gdk_screen_get_root_window(gdk_screen_get_default()),image1_w,image1_h,-1);
 gdk_drawable_set_colormap(pixmap1,gdk_colormap_new(gdk_visual_get_system(),0));
 gdk_draw_pixbuf (pixmap1,NULL,pixbuf1,0,0,0,0,-1,-1,GDK_RGB_DITHER_NONE,0,0);
 /* set image */
 gtk_image_set_from_pixmap(image1,pixmap1,NULL);
 gtk_window_resize( GTK_WINDOW(parentWindow),image1_w,image1_h);
}

gboolean
on_eventbox1_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  gchar datastr[100];
  GtkWidget *parentWindow;
  GtkWidget *data;
  int x1,y1;
  gint width,height;
 
  parentWindow = widget;
  data = lookup_widget(parentWindow,"coorstr");
  x1 = ((int)event->x);
  y1 = ((int)event->y);
  if (x1<0) x1=0;
  if (y1<0) y1=0;
  gtk_window_get_size(GTK_WINDOW(parentWindow),&width,&height);
  if (x1>=width) x1=width-1;
  if (y1>=height) y1=height-1;
  setcoorleftup(x1,y1);
  return FALSE;
}


gboolean
on_eventbox1_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  gchar datastr[100];
  GtkWidget *parentWindow;
  GtkEntry *data;
  int x2,y2;
  gint width,height;
  
  parentWindow = widget;
  data = GTK_ENTRY(lookup_widget(parentWindow,"coorstr"));
  x2 = ((int)event->x);
  y2 = ((int)event->y);
  if (x2<0) x2=0;
  if (y2<0) y2=0;
  gtk_window_get_size(GTK_WINDOW(parentWindow),&width,&height);
  if (x2>=width) x2=width-1;
  if (y2>=height) y2=height-1;
  setcoorrightdown(x2,y2);
  setcoorgetanswer(datastr);
  gtk_entry_set_text (data,datastr);
  setclipboard(datastr);
  return FALSE;
}


void
on_copycoorstrbutton_clicked           (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  const gchar *datastr;
  GtkWidget *parentWindow;
  GtkEntry *data;
  int x2,y2;
  
  parentWindow = GTK_WIDGET(toolbutton);
  data = GTK_ENTRY(lookup_widget(parentWindow,"coorstr"));
  datastr = gtk_entry_get_text (data);
  setclipboard(datastr);
}

void
on_mainwindow_drag_data_received       (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
 GtkWidget *parentWindow;
 GtkImage *image1;
 gint image1_w,image1_h;
 gchar *fn;
 GdkPixbuf *pixbuf1;
 GdkPixmap *pixmap1;
 fn = g_filename_from_uri(data->data,NULL,NULL);
 g_strstrip(fn);
 g_print("Open: %s\n",fn);
 parentWindow = widget;
 image1 = GTK_IMAGE(lookup_widget(parentWindow,"image1"));
 /* get image info */
 gdk_pixbuf_get_file_info(fn,&image1_w,&image1_h);
 /* new pixbuf */
 pixbuf1 = gdk_pixbuf_new_from_file(fn,NULL);
 setmypixbuf(pixbuf1);
 /* new pixmap */
 pixmap1 = gdk_pixmap_new(gdk_screen_get_root_window(gdk_screen_get_default()),image1_w,image1_h,-1);
 gdk_drawable_set_colormap(pixmap1,gdk_colormap_new(gdk_visual_get_system(),0));
 gdk_draw_pixbuf (pixmap1,gdk_gc_new(pixmap1),pixbuf1,0,0,0,0,-1,-1,GDK_RGB_DITHER_NONE,0,0);
 /* set image */
 gtk_image_set_from_pixmap(image1,pixmap1,NULL);
 gtk_window_resize( GTK_WINDOW(parentWindow),image1_w,image1_h);
 g_free(fn);
}

gboolean
on_eventbox1_motion_notify_event       (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  GtkImage *image1;
  GtkWidget *parentWindow;
  int ox,oy;
  int mx,my;
  gint width,height;
  
  parentWindow = widget;
  image1 = GTK_IMAGE(lookup_widget(parentWindow,"image1"));
  ox = mymin(getcoorx1(),(int)event->x);
  oy = mymin(getcoory1(),(int)event->y);
  mx = mymax(getcoorx1(),(int)event->x);
  my = mymax(getcoory1(),(int)event->y);
  if (ox<0) ox=0;
  if (oy<0) oy=0;
  if (mx<0) mx=0;
  if (my<0) my=0;
  gtk_window_get_size(GTK_WINDOW(parentWindow),&width,&height);
  if (ox>=width) ox=width-1;
  if (oy>=height) oy=height-1;
  if (mx>=width) mx=width-1;
  if (my>=height) my=height-1;
  
  drawRectangle(image1,ox,oy,mx,my);
  return FALSE;
}
