
/*  coordin
    Copyright(C) 2006 PaulLiu(Ying-Chun Liu). All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void setclipboard(const gchar *a) {
  GdkAtom ga1;
  GtkClipboard *gc1;
  /*ga1 = gdk_atom_intern ("CLIPBOARD", 0);*/
  gc1 = gtk_clipboard_get(GDK_SELECTION_PRIMARY);
  gtk_clipboard_set_text(gc1,a,-1);
  gtk_clipboard_store(gc1);
  gc1 = gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);
  gtk_clipboard_set_text(gc1,a,-1);
  gtk_clipboard_store(gc1);
}

int mycoor[4];
void setcoorleftup(int x,int y)
{
  mycoor[0]=x;
  mycoor[1]=y;
}
void setcoorrightdown(int x,int y)
{
  mycoor[2]=x;
  mycoor[3]=y;
}
int getcoorx1() {
  return mycoor[0];
}
int getcoory1() {
  return mycoor[1];
}
void setcoorgetanswer(gchar *buf)
{
  int x1,x2,y1,y2,tmp;
  x1 = mycoor[0];
  x2 = mycoor[2];
  y1 = mycoor[1];
  y2 = mycoor[3];
  if (x1>x2) { tmp=x1; x1=x2; x2=tmp; }
  if (y1>y2) { tmp=y1; y1=y2; y2=tmp; }
  g_sprintf(buf,"%d,%d,%d,%d",x1,y1,x2,y2);
  
}

int mymin(int x,int y) {
  if (x<y) return x;
  else return y;
}
int mymax(int x,int y) {
  if (x<y) return y;
  else return x;
}

GdkPixbuf *getmypixbuf_buf=NULL;
GdkPixbuf * getmypixbuf(void) {
 return getmypixbuf_buf;
} 
void setmypixbuf(GdkPixbuf * a) {
 getmypixbuf_buf=a;
}

gboolean drawRectangle_clear(GtkImage* image1,int x1,int y1,int x2,int y2)
{
  GdkPixmap *pixmap1;
  GdkPixbuf *pixbuf1;
  GdkRectangle gr1;
  GdkGC *pixmap1_gc=NULL;
  GdkColor gdkc_black = {0,0,0,0};
  gint image1_w,image1_h;
  int ox,oy,ow,oh;
  if (x1 < x2) {
    ox = x1;
    ow = x2-x1;
  } else {
    ox = x2;
    ow = x1-x2;
  }
  if (y1 < y2) {
    oy = y1;
    oh = y2-y1;
  } else {
    oy = y2;
    oh = y1-y2;
  }
  if (ox<0) ox=0;
  if (oy<0) oy=0;

  gtk_image_get_pixmap(image1,&pixmap1,NULL);
  if (pixmap1==NULL) {
    return FALSE;
  }
  gdk_drawable_get_size(pixmap1,&image1_w,&image1_h);
  
  if (ow>image1_w) ow=image1_w;
  if (oh>image1_h) oh=image1_h;
  
  pixbuf1 = getmypixbuf();
  if (pixbuf1==NULL) {
    return FALSE;
  }
  pixmap1_gc = gdk_gc_new(pixmap1);
  gdk_draw_rectangle(pixmap1,pixmap1_gc,0,ox,oy,ow,oh);
  gdk_draw_pixbuf (pixmap1,pixmap1_gc,pixbuf1,ox,oy,ox,oy,ow,1,GDK_RGB_DITHER_NONE,0,0);
  gdk_draw_pixbuf (pixmap1,pixmap1_gc,pixbuf1,ox,oy,ox,oy,1,oh,GDK_RGB_DITHER_NONE,0,0);
  gdk_draw_pixbuf (pixmap1,pixmap1_gc,pixbuf1,ox,oy+oh,ox,oy+oh,ow+1,1,GDK_RGB_DITHER_NONE,0,0);
  gdk_draw_pixbuf (pixmap1,pixmap1_gc,pixbuf1,ox+ow,oy,ox+ow,oy,1,oh+1,GDK_RGB_DITHER_NONE,0,0);
  g_object_unref(pixmap1_gc);
  return TRUE;
}

int drawRectangle_x1=-1;
int drawRectangle_y1=-1;
int drawRectangle_x2=-1;
int drawRectangle_y2=-1;

gboolean drawRectangle(GtkImage* image1,int x1,int y1,int x2,int y2) 
{
  GdkPixmap *pixmap1;
  GdkPixbuf *pixbuf1;
  gint image1_w,image1_h;
  int ox,oy,ow,oh;
  GdkGC *pixmap1_gc=NULL;
  
  if (drawRectangle_x1 != -1 && drawRectangle_y1 != -1
   && drawRectangle_x2 != -1 && drawRectangle_y2 != -1) {
    drawRectangle_clear(image1,drawRectangle_x1,drawRectangle_y1,
        drawRectangle_x2,drawRectangle_y2);
  }
  
  if (x1 < x2) {
    ox = x1;
    ow = x2-x1;
  } else {
    ox = x2;
    ow = x1-x2;
  }
  if (y1 < y2) {
    oy = y1;
    oh = y2-y1;
  } else {
    oy = y2;
    oh = y1-y2;
  }
  if (ox<0) ox=0;
  if (oy<0) oy=0;

  gtk_image_get_pixmap(image1,&pixmap1,NULL);
  if (pixmap1==NULL) {
    return FALSE;
  }
  gdk_drawable_get_size(pixmap1,&image1_w,&image1_h);
  if (ow>image1_w) ow=image1_w;
  if (oh>image1_h) oh=image1_h;
  pixbuf1 = getmypixbuf();
  if (pixbuf1==NULL) {
    return FALSE;
  }
  //gdk_draw_pixbuf (pixmap1,NULL,pixbuf1,0,0,0,0,-1,-1,GDK_RGB_DITHER_NONE,0,0);
  pixmap1_gc = gdk_gc_new(pixmap1);
  gdk_gc_set_function(pixmap1_gc,GDK_INVERT);
  gdk_draw_rectangle(pixmap1,pixmap1_gc,0,ox,oy,ow,oh);
  gtk_widget_queue_draw_area(GTK_WIDGET(image1), 0,0,image1_w,image1_h);
  drawRectangle_x1=ox;
  drawRectangle_x2=ox+ow;
  drawRectangle_y1=oy;
  drawRectangle_y2=oy+oh;
  g_object_unref(pixmap1_gc);
  return TRUE;
}
